﻿using UnityEngine;
using HarmonyLib;
using AIs;
using System.Collections;
using Enums;
using System;

public class AlexTEST_1 : Mod
{
    [ConsoleCommand("spawn", "spawn <ItemID enum name or value>")]
    public static void Spawn(string[] args)
    {
        if (args.Length == 0)
        {
            return;
        }

        string itemIdString = args[0];
        bool itemDoesNotExist = ItemsManager.Get().StringToItemID(itemIdString) == -1;
        if (itemDoesNotExist)
        {
            Debug.Log("ItemID does not exist: " + itemIdString);
            return;
        }

        Item item = ItemsManager.Get().CreateItem(itemIdString, false);
        if (item != null)
        {
            if (item.m_Info.m_CanBeAddedToInventory)
            {
                Debug.Log("Spawning in inventory: " + itemIdString);
                InventoryBackpack.Get().InsertItem(item, null, null, true, true, true, true, true);
                return;
            }
            Debug.Log("Spawning at player: " + itemIdString);
            Transform playerTransform = Player.Get().transform;
            item.transform.position = playerTransform.position;
            item.transform.rotation = playerTransform.rotation;
            item.ItemsManagerRegister(true);
        }
    }



    [ConsoleCommand("alex", "alex + command/help")]
    public static void PlayerCommand(string[] args)
    {
        if (args.Length == 0)
        {
            return;
        }
        var modifier = args[0];
        switch (modifier)
        {
            case "armor":
                Player.Get().AddItemToInventory("metal_armor");
                Player.Get().AddItemToInventory("metal_armor");
                Player.Get().AddItemToInventory("metal_armor");
                Player.Get().AddItemToInventory("metal_armor");
                break;
            case "energy":
                PlayerConditionModule.Get().m_Energy = 100;
                PlayerConditionModule.Get().m_Stamina = 100;
                break;
            case "hp":
                PlayerConditionModule.Get().m_HP = 100;
                break;
            case "sanity":
                PlayerConditionModule.Get().m_Sanity = 100;
                break;
            case "food":
                PlayerConditionModule.Get().m_Hydration = 100;
                PlayerConditionModule.Get().m_NutritionCarbo = 200;
                PlayerConditionModule.Get().m_NutritionFat = 100;
                PlayerConditionModule.Get().m_NutritionProteins = 100;
                break;
            case "backpack":
                {
                Traverse.Create(InventoryBackpack.Get().m_MaxWeight = 69);
                }
                break;
            case "stat":
                {
                    Debug.Log("HP:      " + Traverse.Create(Player.Get()).Field("m_HP").GetValue());
                    Debug.Log("Energy:  " + Traverse.Create(Player.Get()).Field("m_Energy").GetValue());
                    Debug.Log("Stamina: " + Traverse.Create(Player.Get()).Field("m_Stamina").GetValue());
                    Debug.Log("Sanity:  " + Traverse.Create(Player.Get()).Field("m_Sanity").GetValue());
                    Debug.Log("Test" + "Test2");
                }
                break;
            case "test3":
                PlayerArmorModule.Get().ArmorInsert(Limb.LArm, ItemsManager.Get().CreateItem(Enums.ItemID.metal_armor, false));
                PlayerArmorModule.Get().ArmorInsert(Limb.RArm, ItemsManager.Get().CreateItem(Enums.ItemID.metal_armor, false));
                PlayerArmorModule.Get().ArmorInsert(Limb.LLeg, ItemsManager.Get().CreateItem(Enums.ItemID.metal_armor, false));
                PlayerArmorModule.Get().ArmorInsert(Limb.RLeg, ItemsManager.Get().CreateItem(Enums.ItemID.metal_armor, false));
                break;
            case "test2":
                PlayerArmorModule.Get().ResetArmor();
                break;

        /*    case "test":
                //Debug.Log("Following commands are possible:");
                //Debug.Log("armor    energy  hp  sanity  food    help");
                Item temp = ItemsManager.Get().CreateItem(Enums.ItemID.metal_armor, false);

                Item temp2 = Armor.Find(Enums.ItemID.metal_armor);

                AttachedArmorStatCondition temp4 = new AttachedArmorStatCondition();
               

                //Enums.ItemType temp3 = ItemsManager.Get().CreateItem(Enums.ItemID.metal_armor, false);


                PlayerArmorModule.Get().ArmorInsert(Limb.LArm, Armor.Find(Enums.ItemID.metal_armor));


                //PlayerArmorModule.Get().
                //  InventoryBackpack.Get().InsertItem(temp, null, null, true, true, true, true, true);

                //   PlayerArmorModule.



                // InventoryBackpack.Get().InsertItem(ItemsManager.Get().CreateItem(Enums.ItemID.metal_armor, false), null, null, true, true, true, true, true);




                // Traverse.Create(PlayerArmorModule.Get()).Field(PlayerArmorModule.Get().ArmorInsert(Limb.LArm,)) = 100;
                Traverse.Create(PlayerConditionModule.Get()).Field("m_IncreaseHPLastTime").SetValue(1000);








                InventoryBackpack.Get().m_MaxWeight = 100;

                PlayerConditionModule.Get().GetHP().ToString();
                
                Player.Get().Kill();

                    Debug.Log(PlayerConditionModule.Get().m_MaxHP);
                Traverse.Create(InventoryBackpack.Get().m_MaxWeight = 69);


                Traverse.Create(PlayerConditionModule.Get().m_HP = 100);




               break;
       */     case "help":
                Debug.Log("Following commands are possible:");
                Debug.Log("armor    energy  hp  sanity  food    backpack    help");
                break;
        }
    }

    public void Start()
    {
        Debug.Log("Mod AlexTEST_1 has been loaded!");

        
    }

    public void OnModUnload()
    {
        Debug.Log("Mod AlexTEST_1 has been unloaded!");
    }
}